#include <Windows.h>       //per tutte le applicazioni Windows
#include <stdio.h>         // per sprintf 
#include <string.h>        // per strlen  
#include <memory.h>        //per memcpy

#include "resource.h"      // File creato da appstudio 


#define WSA_ACCEPT   (WM_USER + 0) // messaggio per connessione in corso
#define WSA_DATI     (WM_USER + 1) // messaggio per trasmissione dati
/*
*protitipi delle funzioni
*/
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	GetServerName(HWND, UINT, WPARAM, LPARAM);
/*
*variabili globali
*/
HWND hWnd; //Handle della finestra
HINSTANCE hInst; // current instance

SOCKET sock; //identificatore della Socket
u_short porta; //identificatore dela porta           
SOCKADDR_IN local_sin;  /* struttura per la socket locale - in stile internet*/
SOCKADDR_IN client;    /* struttura per la socket che si collega con la Acceptin stile internet*/
int line;        /* lunghezza dell'indirizzo della socket accettata */ 
char szTemp[80];/*stringa per la visualizzazione dei messaggi temporanei*/

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 
	MSG msg;

	MyRegisterClass(hInstance);

	// inizializza l'applicazione
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}


	// Loop princioale dei messaggi
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  SCOPO: Registra la window class.
//
//  COMMENTO:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (DLGPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= DLGWINDOWEXTRA;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON5));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)COLOR_WINDOW;
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= "Chat";
	wcex.hIconSm		= NULL;//LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_ICON5));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
  

   hInst = hInstance; // Store instance handle in our global variable

  
  hWnd=CreateDialog(hInstance,(LPCTSTR)CHAT,0,NULL);
   if (!hWnd)
   {
      return FALSE;
   }
 
    
    
				 
   ShowWindow(hWnd, nCmdShow);
   
   UpdateWindow(hWnd);

   return TRUE;
}
//
// funzione WndProc
// scopo:Risponde ai messaggi provenienti dagli eventi accaduti
// sulla finestra
// 

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	HWND hLst;
	HDC hdc;

	int stato,count;/* stato variabile usata come riscontro varie operazioni */
	char buf[10000];
	WSADATA WSAData;/*struttura per la negozziazione della versione della DLL Socket*/
      PHOSTENT host;
	  PSERVENT pse;
	
    char szScritta[80];
	switch (message) 
	{
		
	case WM_INITDIALOG:
	    EnableWindow(GetDlgItem(hWnd,IDINVIA),FALSE);
      
		return TRUE;
			break; 
	 
	case WM_CREATE:
         if ((stato = WSAStartup(MAKEWORD(1,1), &WSAData)) == 0) 
		 {
			 MessageBox( hWnd, WSAData.szDescription, WSAData.szSystemStatus, MB_OK);
      
			 buf[0]='\0';
		 }
	  else 
	  {
          sprintf(szTemp, "%d errore n", stato);
          MessageBox( hWnd, szTemp, "Error", MB_OK);
          EnableWindow(GetDlgItem(hWnd,IDCLIENT),FALSE);        
	      EnableWindow(GetDlgItem(hWnd,IDSERVER),FALSE);
		  EnableWindow(GetDlgItem(hWnd,IDINVIA),FALSE);
	  }
		break;
	
	case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
				
			 switch (wmId)
			 {
	        	       
			  case IDESCI:
				    WSACleanup();
					closesocket(sock);
					PostQuitMessage(0);
				   break;
			  case IDSERVER:
				  EnableWindow(GetDlgItem(hWnd,IDCLIENT),FALSE);
				  //preleva il nome del computer locale
				  gethostname(szTemp,sizeof(szTemp));
				  //preleva le informazioni del computer locale
				  host=gethostbyname(szTemp);
				  
				    hLst=GetDlgItem(hWnd,IDC_EDIT1);
					    hdc=GetDC(hLst);
					    strcpy(szScritta,"il nome del computer locale : ");
						strcat(szScritta,szTemp);
					    TextOut(hdc,40,1,szScritta,strlen(szScritta));
				
					//carica nelle stringa l'indirizzo IP
                    sprintf( szTemp, "%u.%u.%u.%u",
                    (unsigned char) host->h_addr_list[0][0],
                    (unsigned char) host->h_addr_list[0][1],
                    (unsigned char) host->h_addr_list[0][2],
                    (unsigned char) host->h_addr_list[0][3]);

            
						
						//stamap l'indirizzo IP
					strcpy(szScritta,"L'Indirizzo IP del computer locale : ");
					strcat(szScritta,szTemp);
					TextOut(hdc,40,20,szScritta,strlen(szScritta));
						ReleaseDC(hLst,hdc);				



				  if( (sock=socket(AF_INET,SOCK_STREAM,0))==INVALID_SOCKET)
					  MessageBox(hWnd,"Non Apre la Socket","",MB_OK);
                  
				  //riempie la sruttura
				  //primo parametro famiglia di protocollo
				  local_sin.sin_family=AF_INET;
				  //secondo parametri l'indirizzo prelevato dalla struttura hostent
				  memcpy((char FAR *)&(local_sin.sin_addr), host->h_addr,host->h_length);
				  pse = getservbyname("ftp", "tcp");
				  //terzo parametro prelevat dalla struttura servent
				  local_sin.sin_port = pse->s_port;
				  
				  if(bind(sock,(LPSOCKADDR) &local_sin,sizeof(local_sin))==SOCKET_ERROR)
					  MessageBox(hWnd,"Non fa la Bind","",MB_OK);

				   
				  
				  if(listen(sock,1)==SOCKET_ERROR)
					  MessageBox(hWnd,"Non fa la Listen","",MB_OK);

				     if(WSAAsyncSelect(sock,hWnd,WSA_ACCEPT,FD_ACCEPT))
                          MessageBox(hWnd,"Non fa la WSA","",MB_OK);
				  break;
			  
			  
			  
			  case IDCLIENT:
				   EnableWindow(GetDlgItem(hWnd,IDSERVER),FALSE);
				  if(DialogBox(hInst,"SERVERNAME",hWnd,GetServerName)==0)
				    MessageBox(hWnd,"Devi inserire il nome di un server","Errore",MB_OK|MB_ICONEXCLAMATION);
				  else
				  {
					
					  sock=socket(AF_INET,SOCK_STREAM,0);
                      host=gethostbyname(szTemp);
					  //riempie la sruttura
				  //primo parametro famiglia di protocollo
				  client.sin_family=AF_INET;
				  //secondo parametri l'indirizzo perlevato dalla struttura hostent
				  memcpy((char FAR *)&(client.sin_addr), host->h_addr,host->h_length);
				  pse = getservbyname("ftp", "tcp");
				  //terzo parametro prelevat dalla struttura servent
				  client.sin_port = pse->s_port;
				 strcpy(buf,"Server    ");
                 strcat(buf,szTemp);
				 strcat(buf," Rilevato\n\nIndirizzo Ip del server\n\n");
				  sprintf( szScritta, "%u.%u.%u.%u",
                    (unsigned char) host->h_addr_list[0][0],
                    (unsigned char) host->h_addr_list[0][1],
                    (unsigned char) host->h_addr_list[0][2],
                    (unsigned char) host->h_addr_list[0][3]);
                    strcat(buf,szScritta);
					MessageBox(hWnd,buf,"Informazioni Server",MB_OK|MB_ICONINFORMATION);
				  
				  bind(sock,(LPSOCKADDR) &client,sizeof(client));
				 
				 if(connect(sock,(LPSOCKADDR) &client,sizeof(client))!=SOCKET_ERROR) 
				 
				 {
					 WSAAsyncSelect(sock,hWnd,WSA_DATI,FD_READ|FD_CLOSE);
				 
					 EnableWindow(GetDlgItem(hWnd,IDINVIA),TRUE);
				 }
				 } 
				  				  
				  break;
              
			  case IDINVIA:
				  line=SendDlgItemMessage(hWnd,IDC_EDIT1,EM_GETLINECOUNT,0,0);
                  line=SendDlgItemMessage(hWnd,IDC_EDIT1,EM_GETLINE,(WPARAM)line-1,(LPARAM) (LPCSTR)szTemp );
                  szTemp[line]='\0';	
				  //GetDlgItemText(hWnd,IDC_EDIT1,szTemp,80);
                  send(sock,szTemp,80,0);
                  break;
			  default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
					 		 
			 
			 }
			break;
		case WSA_ACCEPT:
				  MessageBox(hWnd,"E' arriva una richiesta di aprire una Connessione","",MB_OK);
                  if (
				  (sock=accept( sock,NULL,NULL))!=INVALID_SOCKET)
				  {
				  
				   WSAAsyncSelect(sock,hWnd,WSA_DATI,FD_READ|FD_CLOSE);
				   EnableWindow(GetDlgItem(hWnd,IDINVIA),TRUE);
				  }
				  else
					   MessageBox(hWnd,"non funziona","Errore",MB_OK|MB_ICONEXCLAMATION);
				   break;

			  case WSA_DATI:
				        
				        if (WSAGETSELECTEVENT(lParam) == FD_READ) {
						count=GetDlgItemText(hWnd,IDC_EDIT1,buf,10000);
						if(count){
						buf[count]=13;
						buf[++count]=10;
						buf[++count]='\0';
						}
						stato=recv(sock,szTemp,80,0);
					    szTemp[stato]='\0';
						strcat(buf,szTemp);
						SetDlgItemText(hWnd,IDC_EDIT1,buf);
						
					   
					  					
					}
				   
					else 
						MessageBox(hWnd,"collegamento caduto","",MB_OK);
					break;
			
			 case WM_DESTROY:
				 WSACleanup();
				 closesocket(sock);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}
//
// Funzione GetServerName 
//
//  Scopo: Richiedere all'utente il Nome del server al quale si vuole 
//         collegare nel caso in cui si  scelto la funzionalit Client  
//
LRESULT CALLBACK GetServerName(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	
	
	switch (message) 
	{
		
	case WM_INITDIALOG:
	    
		return TRUE;
			break; 
	 
	case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
				
			 switch (wmId)
			 {
			 case IDOK:
				 GetDlgItemText(hDlg,IDC_NOME,szTemp,80);
			     EndDialog(hDlg,1);
				 break;
			 case IDCANCEL:
	             EndDialog(hDlg,0);		 
				 break;
			 }
			break;
					
		case WM_DESTROY:
			 EndDialog(hDlg,0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


